      program condizioni_stazionarie
      implicit none
      ! universali
      real*8 a,b,caratcomb,etau,m
      ! ingresso compressore
      real*8 tamb,pamb,hamb,cpamb,garia,raria,betac,etac,etamc
      ! uscita compressore
      real*8 p2,t2,h2,cp2,t2is,h2is,lavcomp,passcomp
      ! uscita combustore
      real*8 p3,t3,h3,cp3,rgas,n,gtot,gcomb,alfa,etacomb,etapb
      ! turbina alta pressione
      real*8 p4,t4,h4,cp4,t4is,h4is,betata,etata,etamt1
      ! turbina bassa pressione
      real*8 p5,t5,h5,cp5,t5is,h5is,betatb,pot,etat,etamtb,etas
      integer contat,contab
      character alcano*20
      dimension a(10,7),b(5,4),caratcomb(3),m(20,20)

      call intestazione
      call coefficienti (a)
      call pesomol (b)
      call impostazioni (pot,betac,t3,caratcomb,alcano)

      call ingrcompr (tamb,pamb,a,b,hamb,cpamb,raria)
      
      stop
      end
      
      subroutine intestazione
      implicit none
      write (6,*) ''
      write (6,*) '               POLITECNICO DI BARI'
      write (6,*) '                    Esame di'
      write (6,*) '  MODELLISTICA E SIMULAZIONE DEGLI IMPIANTI MOTORI'
      write (6,*) '            Anno Accademico 2008-2009'
      write (6,*) ''
      write (6,*) '  Prof. Bernardo FORTUNATO'
      write (6,*) '                                  Studente:'
      write (6,*) '                                  Antonio D_AMMARO'
      write (6,*) ''
      write (6,*) ''
      write (6,*) ''
      write (6,*) ''
      write (6,*) 'MODELLO MATEMATICO DI UN IMPIANTO A GAS BIALBERO'
      write (6,*) '            Condizioni stazionarie'
      write (6,*) ''
      return
      end
      
      subroutine coefficienti (a)
      implicit none
      integer i,j
      real*8 a
      dimension a(10,7)
      open (unit=10, file='coefficienti__.txt',form='formatted')
      do i=1,10
      read (10,*) (a(i,j),j=1,7)
      end do
      !DO I=1,10
      !WRITE (6,*) (A(I,J),J=1,7)
      !END DO
      close (10)
      return
      end

      subroutine pesomol (b)
      implicit none
      integer i,j
      real*8 b
      dimension b(5,4)
      open (unit=20, file='aria__.txt',form='formatted')
      do i=1,5
      read (20,*) (b(i,j),j=1,4)
      end do
      !DO I=1,5
      !WRITE (6,*) (B(I,J),J=1,4)
      !END DO
      close (20)
      return
      end
      
      subroutine impostazioni (pot,betac,t3,caratcomb,alcano)
      implicit none
      real*8 betac,t3,valori,caratcomb,pot
      integer comb
      character combustibili*8,alcano*20
      dimension valori (10,4),combustibili(10,6),caratcomb(3)
      integer i,j
      open (unit=30, file='combustibile.txt',form='formatted')
      do i=1,10
      read (30,*) (combustibili(i,j),j=1,6)
      end do
      close (30)
      open (unit=30, file='combustibile.txt',form='formatted')
      do i=1,10
      read (30,*) (valori(i,j),j=1,4)
      end do
      close (30)
      write (6,*)'a'
      write (6,*) 'IMPOSTAZIONE CARATTERISTICHE DELL^IMPIANTO'
      write (6,*) 'Impostare la potenza utile da produrre [MW]'
      read (5,*) pot
      pot=pot*1000000
      write (6,*) 'Impostare il rapporto di compressione'
      read (5,*) betac
      write (6,*) 'Impostare la temperatura di ingresso turbina [K]'
      read (5,*) t3
      do while (t3.gt.1700)
      write (6,*) 'La temperatura impostata e^ troppo alta!'
      write (6,*) 'Inserire un nuovo valore'
      read (5,*) t3
      end do
      ! In realt TIT=1700K  possibile solo con la refrigerazione della
      ! turbina che nel presente modello non  prevista!
      write (6,*) 'Selezionare la sostanza combustibile tra quelle in el
     enco'
      write (6,*) '(digitare il numero corrispondente)'
      do i=1,10
      write (6,*) i,'.  ',(combustibili(i,j),j=5,6)
      end do
      read (5,*) comb
      do j=1,3
      caratcomb(j)=valori(comb,j+1)
      end do
      alcano=combustibili(comb,5)//combustibili(comb,6)
      close (30)
      return
      end
      
      subroutine erre (b,r,runi,z)
      implicit none
      integer i
      real*8 runi,r,b,z,masmolflu
      dimension b(5,4)
      runi=8314.3  ! J/(K*kmole)
      masmolflu=0
      do i=1,5
      masmolflu=masmolflu+b(i,1)*b(i,z)
      end do
      r=runi/masmolflu
      return
      end
      
      subroutine propterm (a,b,temp,runi,cpfluido,hfluido,z)
      implicit none
      integer i,j,start
      real*8 a,b,cpfluido,runi,temp,cpgas,hgas,hfluido,z
      real*8 masmolflu
      dimension a(10,7),b(5,4),cpgas(10),hgas(10)
      start=1
      if (temp.lt.1000)then
      start=start+5
      end if
      cpfluido=0
      hfluido=0
      masmolflu=0
      do i=1,5
      masmolflu=masmolflu+b(i,1)*b(i,z)
      end do
      do i=start,start+4
      cpgas(i)=0
      hgas(i)=0
      do j=1,5
      cpgas(i)=cpgas(i)+a(i,j)*temp**(j-1)
      hgas(i)=hgas(i)+a(i,j)*(temp**j)/j
      end do
      cpgas(i)=runi*cpgas(i)/masmolflu
      hgas(i)=hgas(i)+a(i,6)
      hgas(i)=(runi*hgas(i)/masmolflu)-(b(i-start+1,3)/masmolflu)
      cpfluido=cpfluido+cpgas(i)*b(i-start+1,z)
      hfluido=hfluido+hgas(i)*b(i-start+1,z)
      end do
c     !write (6,*) 'Il calore specifico a pressione costante dell^aria va
c     !le:',cpfluido,' J/kg*K'
c     !write (6,*) 'L^entalpia dell^aria vale:',hfluido,' J/kg'
      return
      end

      subroutine ingrcompr (tamb,pamb,a,b,hamb,cpamb,raria)
      implicit none
      real*8 tamb,pamb,hamb,cpamb,garia,betac,etac,etamc
      real*8 a,b,runi,cparia,haria,raria,r,z
      tamb=288      !K
      pamb=101350   !Pa
      z=2
      call erre (b,r,runi,z)
      raria=r
      call propterm (a,b,tamb,runi,cparia,haria,z)
      hamb=haria
      cpamb=cparia
      return
      end
